//
// Created by 安達 彰典 on 2013/06/16.
// Copyright (c) 2013 ___FULLUSERNAME___. All rights reserved.
//
// To change the template use AppCode | Preferences | File Templates.
//


#import <UIKit/UIKit.h>
#import <CoreGraphics/CoreGraphics.h>
#import "StardustCrossManager.h"
#import "StardustCrossHorizontalView.h"

@interface StardustCrossManager ()
@property dispatch_semaphore_t sem;
@property BOOL infinityMode;
@property BOOL subMode;
@property (retain) StardustCrossHorizontalView *viewHorizontal;
@end


@implementation StardustCrossManager

- (id)init {
    if (self = [super init]) {
        _head = [[StardustMenuContent alloc] init];
        _head.next = nil;
        _sem = dispatch_semaphore_create(1);
        _viewHorizontal = [[StardustCrossHorizontalView alloc] init];
    }
    return self;
}

static int originViewingIdx = 0;

- (BOOL)fallingStars {
    dispatch_semaphore_wait(self.sem, DISPATCH_TIME_FOREVER);
    StardustMenuContent *cur = self.head;
    __block NSUInteger order = 0;
    originViewingIdx = 0;
    while (cur.next) {
        cur = cur.next;
        //if (!cur.fallen) {
        if (1) {
            [UIView animateWithDuration:1.0f animations:^{
                [cur.label setText:[NSString stringWithFormat:@"%d", order]];
                CGRect frame = [self landingRect:cur order:order];
                [cur.view setFrame:frame];
            }                completion:^(BOOL finished) {
                //枠外なら消す
                if ([self outOfScape:cur.view.frame]) {
                    //                [cur.view removeFromSuperview];
                }
            }];
            cur.fallen = YES;
        }
        order++;
    }
    if (order >= 6) {
        self.infinityMode = YES;
    }
    if (self.count == 6) {
        //余分に一つずつ前後のものを表示するため、リストに追加.無限モードにおいて常にViewは8必要。
        //後
        cur.next = [StardustMenuContent stardustCrossContentWithImage:nil text:nil onClick:nil];
        CGRect frame = cur.view.frame;
        frame.origin.y = frame.origin.y + 80;
        [cur.next.view setFrame:frame];
        [cur.next.label setText:[NSString stringWithFormat:@"%d", order - self.count]];
        [self.view addSubview:cur.next.view];
        //前
        cur = cur.next;
        cur.next = [StardustMenuContent stardustCrossContentWithImage:nil text:nil onClick:nil];
        frame = self.head.next.view.frame;
        frame.origin.y = frame.origin.y - 80;
        [cur.next.view setFrame:frame];
        [cur.next.label setText:[NSString stringWithFormat:@"%d", order - 1]];
        [self.view addSubview:cur.next.view];
    }
    dispatch_semaphore_signal(self.sem);
    return self.infinityMode;
}

- (BOOL)outOfScape:(CGRect)frame {
    if (frame.origin.y > 560.0f || frame.origin.y < -80.0f) {
        return YES;
    }
    return NO;
}

- (void)dealloc {
}

- (CGRect)landingRect:(StardustMenuContent *)content order:(NSUInteger)order {
    CGFloat originUnitHeight = 480 / 6;
    CGFloat originY = originUnitHeight * order;
    return CGRectMake(0, originY, 100, 70);
}

- (CGRect)objectivePoint:(StardustMenuContent *)content order:(NSUInteger)order moveType:(SDMoveType)moveType {
    CGFloat originUnitHeight = 480 / 6;
    CGFloat originY;
    if (!self.infinityMode) {
        if (moveType == SDMoveToDowner) {
            originY = originUnitHeight * order;
            return CGRectMake(0, originY, 100, 70);
        } else if (moveType == SDMoveToUpper) {
            CGFloat adjust = 480 - originUnitHeight * self.count;
            originY = originUnitHeight * order + adjust;
            return CGRectMake(0, originY, 100, 70);
        }
    }
    return content.view.frame;
}

- (StardustMenuContent *)tail {
    dispatch_semaphore_wait(self.sem, DISPATCH_TIME_FOREVER);
    StardustMenuContent *cur = self.head;
    while (cur.next) {
        cur = cur.next;
    }
    dispatch_semaphore_signal(self.sem);
    return cur;
}

static BOOL dragNow = NO;

- (void)changeUpDownView:(StardustMenuContent *)cur order:(NSUInteger)order {
    if (cur.view.frame.origin.y < -80.0f && order >= originViewingIdx) {
        originViewingIdx = (originViewingIdx + 1) % self.count;
        CGRect frame = cur.view.frame;
        frame.origin.y = frame.origin.y + self.count * 80.0f;
        [cur.view setFrame:frame];
    } else if (cur.view.frame.origin.y > self.count * 80.0f - 80.0f) {
        if (--originViewingIdx < 0) {
            originViewingIdx = self.count - 1;
        }
        CGRect frame = cur.view.frame;
        frame.origin.y = frame.origin.y - self.count * 80.0f;
        [cur.view setFrame:frame];
    }
}

static SDMoveType touchEndMoveToUpper = SDMoveNeutral;

- (void)dragMovingView:(CGFloat)touchMoveY origin:(CGFloat)touchBeganY {
    CGFloat distance = touchMoveY - touchBeganY;
    static CGFloat beforeDistance = 0;
    if(self.subMode){
        return;
    }
    CGRect frame;
    NSInteger order = 0;
    dispatch_semaphore_wait(self.sem, DISPATCH_TIME_FOREVER);
    StardustMenuContent *cur = self.head;
    while (cur.next) {
        cur = cur.next;
        frame = cur.view.frame;
        frame.origin.y = frame.origin.y + distance - (dragNow ? beforeDistance : 0);
        [cur.view setFrame:frame];
        if (self.infinityMode) {
            if ([self outOfScape:cur.view.frame]) {
                [self changeUpDownView:cur order:order];
            }
        }
        order++;
    }
    dragNow = YES;
    if (distance > beforeDistance) {
        touchEndMoveToUpper = SDMoveToDowner;
    } else if (distance > beforeDistance) {
        touchEndMoveToUpper = SDMoveToUpper;
    } else {
        touchEndMoveToUpper = SDMoveNeutral;
    }
    beforeDistance = distance;
    dispatch_semaphore_signal(self.sem);

}

static NSInteger parentOrder = 0;

- (void)dragMovingEnd:(CGPoint)touchPoint {
    SDMoveType moveType = SDMoveNeutral;
    if(self.subMode){
        [self closeSubMenus];
        return;
    }
    StardustMenuContent *tail = self.tail;
    dispatch_semaphore_wait(self.sem, DISPATCH_TIME_FOREVER);
    StardustMenuContent *cur = self.head;
    __block NSUInteger order = 0;
    if (self.head.next && !self.infinityMode) {
        if (self.head.next.view.frame.origin.y < 0) {
            moveType = SDMoveToDowner;
        } else if (tail.view.frame.origin.y > (480 - 70)) {
            moveType = SDMoveToUpper;
        }
    }
    while (cur.next) {
        cur = cur.next;
        if (!cur.fallen && !self.infinityMode) {
            [UIView animateWithDuration:0.3f animations:^{
                CGRect frame = [self objectivePoint:cur order:order moveType:moveType];
                [cur.view setFrame:frame];
            }                completion:^(BOOL finished) {
                //枠外なら消す
                if ([self outOfScape:cur.view.frame]) {
                    [cur.view removeFromSuperview];
                }
            }];
        } else if (self.infinityMode) {
            //慣性を実装+枠外なら消す
            __block CGRect frame = cur.view.frame;
            if (!dragNow) { /* タップ時処理 */
                if (CGRectContainsPoint(cur.view.frame, touchPoint)) {
                    /* サブメニューがあれば開く */
                    if (cur.head.next) {
                        [self openSubMenus:cur];
                        parentOrder = order;
                    }
                    /* クリックハンドラ実行 */
                    dispatch_async(dispatch_get_main_queue(), ^{
                        if (cur.onClick) {
                            cur.onClick();
                        }
                    });
                    break;
                }
                continue;
            }
            [UIView animateWithDuration:0.1f animations:^{
                if (touchEndMoveToUpper == SDMoveToUpper) {
                    frame.origin.y = frame.origin.y - 30.0f;
                    [cur.view setFrame:frame];
                } else if (touchEndMoveToUpper == SDMoveToDowner) {
                    frame.origin.y = frame.origin.y + 30.0f;
                    [cur.view setFrame:frame];
                }
            }                completion:^(BOOL finished) {
                if ([self outOfScape:cur.view.frame]) {
                    [self changeUpDownView:cur order:order];
                }
            }];
        }
        order++;
    }
    dispatch_semaphore_signal(self.sem);
    dragNow = NO;
}

#ifdef NEVER
- (CGRect)subbingRect:(StardustMenuContent *)content order:(NSUInteger)order {
    CGFloat scale = 5;
    CGFloat originUnitHeight = 480 / (6 * scale); /*1/5の大きさになる*/
    CGFloat originY = originUnitHeight * order;
    return CGRectMake(-50, originY, 100 / scale, 70 / scale);
}
#endif

- (CGRect)subbingRect:(StardustMenuContent *)content order:(NSUInteger)order {
    CGRect frame = content.view.frame;
    frame.origin.x = frame.origin.x - 50;
    return frame;
}
- (CGRect)mainingRect:(StardustMenuContent *)content order:(NSUInteger)order {
    CGRect frame = content.view.frame;
    frame.origin.x = frame.origin.x + 50;
    return frame;
}

- (void)openSubMenus:(StardustMenuContent *)content {
    __block NSUInteger order = 0;

    CGRect frame = content.view.frame;
    [self.viewHorizontal setFrame:CGRectMake(0, frame.origin.y, 320.0f, 70.0f)];
    [self.view addSubview:self.viewHorizontal];
    [self.viewHorizontal openMenus:content];

    StardustMenuContent *cur = self.head;
    order = 0;
    while (cur.next) {
        cur = cur.next;
        [UIView animateWithDuration:0.3f animations:^{
            CGRect frame = [self subbingRect:cur order:order];
            [cur.view setFrame:frame];
        }                completion:^(BOOL finished) {
        }];
        order++;
    }
    self.subMode = YES;
}

- (void)closeSubMenus {
    self.subMode = NO;
    StardustMenuContent *cur = self.head;
    __block NSUInteger order = 0;
    while (cur.next) {
        cur = cur.next;
        if(order == parentOrder){
            [self.viewHorizontal closeMenus:cur];
        }
        [UIView animateWithDuration:0.3f animations:^{
            CGRect frame = [self mainingRect:cur order:order];
            [cur.view setFrame:frame];
        }                completion:^(BOOL finished) {
            [self.viewHorizontal removeFromSuperview];
        }];
        order++;
    }

}

- (StardustMenuContent *)addMenuWithImage:(UIImage *)image text:(NSString *)text onClick:(dispatch_block_t)click {
    StardustMenuContent *addition;
    addition = [StardustMenuContent stardustCrossContentWithImage:image text:text onClick:click];
    if (!addition) {
        return nil;
    }
    [self tail].next = addition;
    self.count++;

    CGFloat x = rand() % (320 - 300);
    CGFloat y = rand() % (480 - 300);
    CGFloat width = rand() % 200;
    CGFloat height = width * 0.6;
    CGRect frame = CGRectMake(x, y, width, height);
    NSLog(@"addMenuWithImage: %f,%f,%f,%f", x, y, width, height);

    [addition.view setBackgroundColor:[UIColor blueColor]];
    [addition.view setFrame:frame];
    [self.view addSubview:addition.view];

    return addition;
}

- (void)removeMenuWithTag:(NSString *)tag {
}

- (NSString *)addMenuChildWithTag:(NSString *)tag image:(UIImage *)image text:(NSString *)text onClick:(dispatch_block_t)click {
    dispatch_semaphore_wait(self.sem, DISPATCH_TIME_FOREVER);
    StardustMenuContent *cur = self.head;
    StardustMenuContent *child = nil;
    while (cur.next) {
        cur = cur.next;
        if ([cur.tag isEqualToString:tag]) {
            child = [cur tail];
            child.next = [StardustMenuContent stardustCrossContentWithImage:image text:text onClick:click];
            child.countChild++;
            break;
        }
    }
    dispatch_semaphore_signal(self.sem);
    return child ? child.next.tag : nil;
}

- (void)removeMenuChildWithTag:(NSString *)tag {

}


@end