//
//  StardustCrossView.h
//  StardustCrossView
//
//  Created by 安達 彰典 on 06/16/13.
//  Copyright (c) 2013 安達 彰典. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>

@interface StardustCrossView : UIView

@property (nonatomic, assign) BOOL autoFallingStar;

/**
* Initializes instance.
* @param frame The CGRect.
* @return The `StardustCrossView` instance.
*/
- (id)initWithFrame:(CGRect)frame;

/**
* Performs animation falling stars.
*/
- (void)fallingStars;

/**
* Adds a menu.
* @param image The image in menu if `text` is nil.
* @param text The text in menu if `image` is nil.
* @param click The handler on click.
* @return The menu `tag`.
*/
- (NSString *)addMenuWithImage:(UIImage *)image text:(NSString *)text onClick:(dispatch_block_t)click;

/**
* Removes a menu.
* @param tag The tag of target menu.
*/
- (void)removeMenuWithTag:(NSString *)tag;

/**
* Adds a child menu.
* @param image The image in menu if `text` is nil.
* @param text The text in menu if `image` is nil.
* @param click The handler on click.
* @param tag The tag of the parent menu.
* @return The menu `tag`.
*/
- (NSString *)addMenuChildWithImage:(UIImage *)image text:(NSString *)text onClick:(dispatch_block_t)click tag:(NSString *)tag;

/**
* Removes a menu.
* @param tag The tag of target menu.
*/
- (void)removeMenuChildWithTag:(NSString *)tag;

@end



