//
//  StardustCrossView.m
//  StardustCrossView
//
//  Created by 安達 彰典 on 06/16/13.
//  Copyright (c) 2013 安達 彰典. All rights reserved.
//

#import <CoreGraphics/CoreGraphics.h>
#import "StardustCrossView.h"
#import "StardustCrossManager.h"
#import "StardustMenuContent.h"

@interface StardustCrossView ()
@property(nonatomic, retain) StardustCrossManager *manager;
@end

@implementation StardustCrossView

- (id)initWithFrame:(CGRect)frame {
    if (self = [super initWithFrame:frame]) {
        _autoFallingStar = YES;
        _manager = [[StardustCrossManager alloc] init];
        _manager.view = self;
        [self setAlpha:0.3f];
    }
    return self;
}

/**
* 初期座標はfallingStar時に決定される
*/
- (void)fallingStars {
    [self.manager fallingStars];
}

- (NSString *)addMenuWithImage:(UIImage *)image text:(NSString *)text onClick:(dispatch_block_t)click {
    StardustMenuContent *content = [self.manager addMenuWithImage:image text:text onClick:click];
    if (!content.tag) {
        return nil;
    }
    return content.tag;
}

- (void)removeMenuWithTag:(NSString *)tag {
    [self.manager removeMenuWithTag:tag];
}

- (NSString *)addMenuChildWithImage:(UIImage *)image text:(NSString *)text onClick:(dispatch_block_t)click tag:(NSString *)tag {
    return [self.manager addMenuChildWithTag:tag image:image text:text onClick:click];
}

- (void)removeMenuChildWithTag:(NSString *)tag {
    [self.manager removeMenuChildWithTag:tag];
}

#pragma mark - touchEvent

static CGPoint clickPos;

- (void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event
{
    for (UITouch *touch in touches) {
        clickPos = [touch locationInView:self];
        break;
    }
}

- (void)touchesMoved:(NSSet *)touches withEvent:(UIEvent *)event {
    for (UITouch *touch in touches){
        CGPoint pt = [touch locationInView:self];
        [self.manager dragMovingView:pt.y origin:clickPos.y];
        break;
    }
}

- (void)touchesEnded:(NSSet *)touches withEvent:(UIEvent *)event {
    for (UITouch *touch in touches){
        CGPoint pt = [touch locationInView:self];
        [self.manager dragMovingEnd:pt];
        break;
    }
}


@end
